var http = require('http');
var Log = require('./../util/log');
var MetaContext = require('./meta-context');
var BitSensor = require('./bitsensor');
var request = require('request');
var ApiConnector = function () {
    this.user = '';
    this.uri = '';
    this.data = [];
    this.apiKey = '';
    this.action = '';
};

ApiConnector.ACTION_AUTHORIZE = 'authorize';
ApiConnector.ACTION_LOG = 'log';

ApiConnector.prototype.from = function (user, apiKey) {
    this.user = user;
    this.apiKey = apiKey;
    return this;
};

ApiConnector.prototype.with = function (data) {
    this.data = data;
    return this;
};

ApiConnector.prototype.to = function (uri) {
    this.uri = uri;
    return this;
};

ApiConnector.prototype.post = function (action) {
    this.action = action;
    return this;
};

ApiConnector.prototype.send = function () {
    this.data[MetaContext.NAME] = {};
    this.data[MetaContext.NAME][MetaContext.USER] = this.user;
    this.data[MetaContext.NAME][MetaContext.API_KEY] = this.apiKey;
    this.data[MetaContext.NAME][MetaContext.PROVIDER] = MetaContext.PROVIDER_NODEJS;
    this.data[MetaContext.NAME][MetaContext.PROVIDER_VERSION] = BitSensor.VERSION;

    var content = {};
    content[MetaContext.DATA] = this.data;
    content[MetaContext.ENCRYPTION] = false;
    var json = JSON.stringify(content);

    var options = {
        host: require('url').parse(this.uri).hostname,
        port: require('url').parse(this.uri).port,
        path: require('url').parse(this.uri).path + this.action,
        method: this.getRequestType(this.action),
        keepAlive: true
    };
    Log.d(json);
    Log.d(options);
    var responseBody = '';
        request({
            url: this.uri+"/"+this.action,
            method: this.getRequestType(this.action),
            json: content,
        }, function (error, response, body) {

        });
};

ApiConnector.prototype.getRequestType = function (action) {
    switch (action) {
        case ApiConnector.ACTION_AUTHORIZE:
            return 'POST';
        case ApiConnector.ACTION_LOG:
            return 'POST';
        default:
            return 'GET';
    }
};

module.exports = ApiConnector;