var os = require('os');
var EndpointContext = require('../endpoint-context');
var Handler = require('../../handler/handler');

var EnvironmentHandler = function(){

}

EnvironmentHandler.prototype = new Handler();

EnvironmentHandler.prototype.handle = function(datapoint){
    datapoint.addEndpointContext(new EndpointContext("os.name", os.type()));
    datapoint.addEndpointContext(new EndpointContext("os.version", os.release()));
    datapoint.addEndpointContext(new EndpointContext("os.arch", os.arch()));
    datapoint.addEndpointContext(new EndpointContext("node-js.version", process.version));
    datapoint.addEndpointContext(new EndpointContext("node-js.vendor","node-js"));
    datapoint.addEndpointContext(new EndpointContext("host.name", os.hostname()));
    datapoint.addEndpointContext(new EndpointContext("memory.size",os.totalmem()));
    datapoint.addEndpointContext(new EndpointContext("memory.used", process.memoryUsage().heapTotal));
}

module.exports = EnvironmentHandler;