var expect = require('chai').expect;
require('./../core/init');

describe('bitSensor', function () {
    describe('initialized', function () {
        bitSensor.runSession(function () {
            it('should be done', function () {
                expect(bitSensor.isInitialized()).to.be.false;
            });
        });
    });
    describe('isDisabled', function () {
        bitSensor.runSession(function () {
            it('should be 0', function () {
                expect(bitSensor.isDisabled == 0).to.be.true;
            });
            it('should be 1', function () {
                bitSensor.setDisabled();
                expect(bitSensor.isDisabled == 1).to.be.true;
            });
            it('should be true', function () {
                expect(bitSensor.hasBeenDisabled()).to.be.true;
            });
            it('should be 0', function () {
                bitSensor.setEnabled();
                expect(bitSensor.isDisabled == 0).to.be.true;
            });
            it('should be false', function () {
                expect(bitSensor.hasBeenDisabled()).to.be.false;
            });
        });
    });
    describe('isHandlingRequest', function () {
        it('should be 0', function () {
            expect(bitSensor.isHandingRequest == null).to.be.true;
        });

        it('should be 1', function () {
            bitSensor.runSession(function () {

                expect(bitSensor.isHandlingRequest == 1).to.be.true;
            });
        });
        it('should be 2', function () {
            bitSensor.runSession(function () {
                bitSensor.traceIncrement();
                expect(bitSensor.isHandlingRequest == 2).to.be.true;

            });
        });
        it('should be 1', function () {
            bitSensor.runSession(function () {
                expect(bitSensor.traceDecrement() == 1).to.be.true;
            });
        });
    });
});
