require('./../core/init');
var expect = require('chai').expect;
var ApplicationHandler = require('../core/handler/application-handler');
var VersionHandler = require('../core/handler/bitsensor-version-handler');
var EnvironmentHandler = require('../core/handler/environment-handler');
var TimeHandler = require('../core/handler/time-handler');
var Datapoint = require('./../core/datapoint');


describe('Post handle', function () {
    describe('Integration', function () {
        it('should not be empty', function () {
            var datapoint = new Datapoint();
            bitSensor.postHandlers[1].handle(datapoint);

            expect(datapoint.endpointCollection.length).to.be.above(0);
        });
        it('should not be empty', function () {
            var datapoint = new Datapoint();
            bitSensor.postHandlers[0].handle(datapoint);
            expect(datapoint.metaContextCollection.length).to.be.above(0);
        });
    });
    describe('Unit', function () {
        describe('Version handler', function () {
            it('should not be empty', function () {
                bitSensor.postHandlers = [];
                bitSensor.addPostHandler(new VersionHandler());
                expect(bitSensor.postHandlers.length).to.be.above(0);
            });
        });
        describe('Time handler', function () {
            it('should not be empty', function () {
                bitSensor.postHandlers = [];
                bitSensor.addPostHandler(new TimeHandler());
                expect(bitSensor.postHandlers.length).to.be.above(0);
            });
        });
        describe('Environment handler', function () {
            it('should not be empty', function () {
                bitSensor.postHandlers = [];
                bitSensor.addPostHandler(new EnvironmentHandler());
                expect(bitSensor.postHandlers.length).to.be.above(0);
            });
        });
        describe('Application handler', function () {
            it('should not be empty', function () {
                bitSensor.postHandlers = [];
                bitSensor.addPostHandler(new ApplicationHandler());
                expect(bitSensor.postHandlers.length).to.be.above(0);
            });
        });
    });
});
