var expect = require('chai').expect;
require('./../core/init');
var Datapoint = require('./../core/datapoint');
var Context = require('./../core/context');
var EndpointContext = require('./../core/endpoint-context');
var Error = require('./../core/error');
var MetaContext = require('./../core/meta-context');
var IpContext = require('./../core/ip-context');


bitSensor.session.run(function () {
    var datapoint = bitSensor.getDatapoint();
    bitSensor.runPostHandlers();

    describe('Datapoint', function () {
        describe('add context', function () {
            var datapoint = new Datapoint();
            it('should be empty', function () {
                expect(datapoint.endpointCollection.length==0).to.be.true;
            });
        });
        describe('add context', function () {
            var datapoint = new Datapoint();
            datapoint.addContext(new Context("testName", "testValue"));
            it('should not be empty', function () {
                expect(datapoint.contextCollection.length).to.be.above(0);
            });
        });
        describe('add endpoint', function () {
            var datapoint = new Datapoint();
            datapoint.addEndpointContext(new EndpointContext("testName", "testValue"));
            it('should not be empty', function () {
                expect(datapoint.endpointCollection.length).to.be.above(0);
            });
        });
        describe('add meta context', function () {
            var datapoint = new Datapoint();
            datapoint.addMetaContext(new MetaContext("testName", "testValue"));
            it('should not be empty', function () {
                expect(datapoint.metaContextCollection.length).to.be.above(0);
            });
        });
        describe('add error', function () {
            var datapoint = new Datapoint();
            datapoint.addError(new Error("testCode", "testDescription", "test", "test", "test", "test"));
            it('should not be empty', function () {
                expect(datapoint.errorCollection.length).to.be.above(0);
            });
        });
        describe('add ip context', function () {
            var datapoint = new Datapoint();
            datapoint.addContext(new IpContext("127.0.0.1"));
            it('should not be empty', function () {
                expect(datapoint.contextCollection.length).to.be.above(0);
            });
        });
    });
});
